import * as ec2 from '@aws-cdk/aws-ec2';
import * as eks from '@aws-cdk/aws-eks';
import * as iam from '@aws-cdk/aws-iam';
import * as cdk from '@aws-cdk/core';
import * as runner from './runner';
/**
 *
 */
export interface ProviderProps {
    /**
     *
     */
    readonly vpc?: ec2.IVpc;
}
/**
 *
 */
export interface RoleProps {
    /**
     *
     */
    readonly accountId: string;
    /**
     *
     */
    readonly externalId: string;
}
/**
 *
 */
export declare class Provider extends cdk.Construct {
    /**
     *
     */
    gitlabEksRole?: iam.IRole;
    /**
     *
     */
    readonly vpc: ec2.IVpc;
    /**
     *
     */
    constructor(scope: cdk.Construct, id: string, props?: ProviderProps);
    /**
     *
     */
    createFargateRunner(executor?: runner.JobExecutorOptions): void;
    /**
     *
     */
    createEksCluster(scope: cdk.Construct, id: string, props: eks.ClusterProps): eks.Cluster;
    /**
     *
     */
    createSecurityGroup(): ec2.SecurityGroup;
    /**
     *
     */
    createEksServiceRole(): iam.Role;
    /**
     *
     */
    createGitlabManagedEksRole(props: RoleProps): void;
}
